'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.describeFlowType = describeFlowType;
exports.plain = plain;
exports.union = union;
function describeFlowType(type) {
  var level = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

  switch (type.name) {
    case 'union':
      return union(type, level);
    case 'Array':
      return describeFlowType(type.elements[0], level);
    case 'signature':
      return plain(type.raw || type.name, level);
    case 'custom':
      return plain(type.raw || type.name, level);
    default:
      return plain(type.raw || type.value || type.name, level);
  }
}

function plain(value, level) {
  if (level > 0) return value;
  var output = '\n```\n';
  output += value;
  output += '\n```\n';
  return output;
}

function union(type, level) {
  if (type.elements) {
    var initial = '\nShould be one of the following:\n\n';
    return type.elements.filter(function (type) {
      return type.name !== 'unknown';
    }).reduce(function (output, type) {
      return output + ('\n' + describeFlowType(type, level + 1));
    }, initial + '```') + '\n```\n';
  }

  return '';
}